package proxy

// Code generated by http://github.com/gojuno/minimock (3.0.6). DO NOT EDIT.

import (
	"context"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"github.com/gojuno/minimock/v3"
	"github.com/rekby/lets-proxy2/internal/docker"
	"github.com/rekby/lets-proxy2/internal/domain"
)

// DockerInterfaceMock implements dockerInterface
type DockerInterfaceMock struct {
	t minimock.Tester

	funcGetTarget          func(ctx context.Context, domain domain.DomainName) (dp1 *docker.DomainInfo, err error)
	inspectFuncGetTarget   func(ctx context.Context, domain domain.DomainName)
	afterGetTargetCounter  uint64
	beforeGetTargetCounter uint64
	GetTargetMock          mDockerInterfaceMockGetTarget
}

// NewDockerInterfaceMock returns a mock for dockerInterface
func NewDockerInterfaceMock(t minimock.Tester) *DockerInterfaceMock {
	m := &DockerInterfaceMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.GetTargetMock = mDockerInterfaceMockGetTarget{mock: m}
	m.GetTargetMock.callArgs = []*DockerInterfaceMockGetTargetParams{}

	return m
}

type mDockerInterfaceMockGetTarget struct {
	mock               *DockerInterfaceMock
	defaultExpectation *DockerInterfaceMockGetTargetExpectation
	expectations       []*DockerInterfaceMockGetTargetExpectation

	callArgs []*DockerInterfaceMockGetTargetParams
	mutex    sync.RWMutex
}

// DockerInterfaceMockGetTargetExpectation specifies expectation struct of the dockerInterface.GetTarget
type DockerInterfaceMockGetTargetExpectation struct {
	mock    *DockerInterfaceMock
	params  *DockerInterfaceMockGetTargetParams
	results *DockerInterfaceMockGetTargetResults
	Counter uint64
}

// DockerInterfaceMockGetTargetParams contains parameters of the dockerInterface.GetTarget
type DockerInterfaceMockGetTargetParams struct {
	ctx    context.Context
	domain domain.DomainName
}

// DockerInterfaceMockGetTargetResults contains results of the dockerInterface.GetTarget
type DockerInterfaceMockGetTargetResults struct {
	dp1 *docker.DomainInfo
	err error
}

// Expect sets up expected params for dockerInterface.GetTarget
func (mmGetTarget *mDockerInterfaceMockGetTarget) Expect(ctx context.Context, domain domain.DomainName) *mDockerInterfaceMockGetTarget {
	if mmGetTarget.mock.funcGetTarget != nil {
		mmGetTarget.mock.t.Fatalf("DockerInterfaceMock.GetTarget mock is already set by Set")
	}

	if mmGetTarget.defaultExpectation == nil {
		mmGetTarget.defaultExpectation = &DockerInterfaceMockGetTargetExpectation{}
	}

	mmGetTarget.defaultExpectation.params = &DockerInterfaceMockGetTargetParams{ctx, domain}
	for _, e := range mmGetTarget.expectations {
		if minimock.Equal(e.params, mmGetTarget.defaultExpectation.params) {
			mmGetTarget.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetTarget.defaultExpectation.params)
		}
	}

	return mmGetTarget
}

// Inspect accepts an inspector function that has same arguments as the dockerInterface.GetTarget
func (mmGetTarget *mDockerInterfaceMockGetTarget) Inspect(f func(ctx context.Context, domain domain.DomainName)) *mDockerInterfaceMockGetTarget {
	if mmGetTarget.mock.inspectFuncGetTarget != nil {
		mmGetTarget.mock.t.Fatalf("Inspect function is already set for DockerInterfaceMock.GetTarget")
	}

	mmGetTarget.mock.inspectFuncGetTarget = f

	return mmGetTarget
}

// Return sets up results that will be returned by dockerInterface.GetTarget
func (mmGetTarget *mDockerInterfaceMockGetTarget) Return(dp1 *docker.DomainInfo, err error) *DockerInterfaceMock {
	if mmGetTarget.mock.funcGetTarget != nil {
		mmGetTarget.mock.t.Fatalf("DockerInterfaceMock.GetTarget mock is already set by Set")
	}

	if mmGetTarget.defaultExpectation == nil {
		mmGetTarget.defaultExpectation = &DockerInterfaceMockGetTargetExpectation{mock: mmGetTarget.mock}
	}
	mmGetTarget.defaultExpectation.results = &DockerInterfaceMockGetTargetResults{dp1, err}
	return mmGetTarget.mock
}

//Set uses given function f to mock the dockerInterface.GetTarget method
func (mmGetTarget *mDockerInterfaceMockGetTarget) Set(f func(ctx context.Context, domain domain.DomainName) (dp1 *docker.DomainInfo, err error)) *DockerInterfaceMock {
	if mmGetTarget.defaultExpectation != nil {
		mmGetTarget.mock.t.Fatalf("Default expectation is already set for the dockerInterface.GetTarget method")
	}

	if len(mmGetTarget.expectations) > 0 {
		mmGetTarget.mock.t.Fatalf("Some expectations are already set for the dockerInterface.GetTarget method")
	}

	mmGetTarget.mock.funcGetTarget = f
	return mmGetTarget.mock
}

// When sets expectation for the dockerInterface.GetTarget which will trigger the result defined by the following
// Then helper
func (mmGetTarget *mDockerInterfaceMockGetTarget) When(ctx context.Context, domain domain.DomainName) *DockerInterfaceMockGetTargetExpectation {
	if mmGetTarget.mock.funcGetTarget != nil {
		mmGetTarget.mock.t.Fatalf("DockerInterfaceMock.GetTarget mock is already set by Set")
	}

	expectation := &DockerInterfaceMockGetTargetExpectation{
		mock:   mmGetTarget.mock,
		params: &DockerInterfaceMockGetTargetParams{ctx, domain},
	}
	mmGetTarget.expectations = append(mmGetTarget.expectations, expectation)
	return expectation
}

// Then sets up dockerInterface.GetTarget return parameters for the expectation previously defined by the When method
func (e *DockerInterfaceMockGetTargetExpectation) Then(dp1 *docker.DomainInfo, err error) *DockerInterfaceMock {
	e.results = &DockerInterfaceMockGetTargetResults{dp1, err}
	return e.mock
}

// GetTarget implements dockerInterface
func (mmGetTarget *DockerInterfaceMock) GetTarget(ctx context.Context, domain domain.DomainName) (dp1 *docker.DomainInfo, err error) {
	mm_atomic.AddUint64(&mmGetTarget.beforeGetTargetCounter, 1)
	defer mm_atomic.AddUint64(&mmGetTarget.afterGetTargetCounter, 1)

	if mmGetTarget.inspectFuncGetTarget != nil {
		mmGetTarget.inspectFuncGetTarget(ctx, domain)
	}

	mm_params := &DockerInterfaceMockGetTargetParams{ctx, domain}

	// Record call args
	mmGetTarget.GetTargetMock.mutex.Lock()
	mmGetTarget.GetTargetMock.callArgs = append(mmGetTarget.GetTargetMock.callArgs, mm_params)
	mmGetTarget.GetTargetMock.mutex.Unlock()

	for _, e := range mmGetTarget.GetTargetMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.dp1, e.results.err
		}
	}

	if mmGetTarget.GetTargetMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetTarget.GetTargetMock.defaultExpectation.Counter, 1)
		mm_want := mmGetTarget.GetTargetMock.defaultExpectation.params
		mm_got := DockerInterfaceMockGetTargetParams{ctx, domain}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetTarget.t.Errorf("DockerInterfaceMock.GetTarget got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetTarget.GetTargetMock.defaultExpectation.results
		if mm_results == nil {
			mmGetTarget.t.Fatal("No results are set for the DockerInterfaceMock.GetTarget")
		}
		return (*mm_results).dp1, (*mm_results).err
	}
	if mmGetTarget.funcGetTarget != nil {
		return mmGetTarget.funcGetTarget(ctx, domain)
	}
	mmGetTarget.t.Fatalf("Unexpected call to DockerInterfaceMock.GetTarget. %v %v", ctx, domain)
	return
}

// GetTargetAfterCounter returns a count of finished DockerInterfaceMock.GetTarget invocations
func (mmGetTarget *DockerInterfaceMock) GetTargetAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetTarget.afterGetTargetCounter)
}

// GetTargetBeforeCounter returns a count of DockerInterfaceMock.GetTarget invocations
func (mmGetTarget *DockerInterfaceMock) GetTargetBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetTarget.beforeGetTargetCounter)
}

// Calls returns a list of arguments used in each call to DockerInterfaceMock.GetTarget.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetTarget *mDockerInterfaceMockGetTarget) Calls() []*DockerInterfaceMockGetTargetParams {
	mmGetTarget.mutex.RLock()

	argCopy := make([]*DockerInterfaceMockGetTargetParams, len(mmGetTarget.callArgs))
	copy(argCopy, mmGetTarget.callArgs)

	mmGetTarget.mutex.RUnlock()

	return argCopy
}

// MinimockGetTargetDone returns true if the count of the GetTarget invocations corresponds
// the number of defined expectations
func (m *DockerInterfaceMock) MinimockGetTargetDone() bool {
	for _, e := range m.GetTargetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetTargetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetTargetCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetTarget != nil && mm_atomic.LoadUint64(&m.afterGetTargetCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetTargetInspect logs each unmet expectation
func (m *DockerInterfaceMock) MinimockGetTargetInspect() {
	for _, e := range m.GetTargetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to DockerInterfaceMock.GetTarget with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetTargetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetTargetCounter) < 1 {
		if m.GetTargetMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to DockerInterfaceMock.GetTarget")
		} else {
			m.t.Errorf("Expected call to DockerInterfaceMock.GetTarget with params: %#v", *m.GetTargetMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetTarget != nil && mm_atomic.LoadUint64(&m.afterGetTargetCounter) < 1 {
		m.t.Error("Expected call to DockerInterfaceMock.GetTarget")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *DockerInterfaceMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockGetTargetInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *DockerInterfaceMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *DockerInterfaceMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockGetTargetDone()
}
